from dataclasses import dataclass, field
from enum import Enum, auto
from importlib.machinery import SourceFileLoader
from importlib.util import module_from_spec, spec_from_loader
import pytest
from unittest.mock import patch
from pathlib import Path

from build123d import BuildPart, Box, Part, Sphere, Align, Mode, Location

from fb_library.hexwall import HexWall


class TestClickfit:
    def test_hexwall(self):
        pattern = HexWall(10, 10, 1, 1, 0.2)
        assert pattern.is_valid()

    def test_direct_run(self):

        with (
            patch("build123d.export_stl"),
            patch("pathlib.Path.mkdir"),
            patch("pathlib.Path.exists"),
            patch("pathlib.Path.is_dir"),
            patch("ocp_vscode.show"),
            patch("ocp_vscode.save_screenshot"),
        ):
            loader = SourceFileLoader("__main__", "src/fb_library/hexwall.py")
            loader.exec_module(
                module_from_spec(spec_from_loader(loader.name, loader))
            )
